<?php

namespace App\Traits;
use Illuminate\Support\Str;
use App\Models\ModelHasRoles;
use App\Repositories\Auth\RoleRepository;
use App\Repositories\Auth\UserRepository;

use App\Repositories\UserdetailRepository;
use App\Repositories\Auth\BiodataRepository;

trait LoginTrait
{
    private $userRepo;
    private $roleRepo;
    private $biodataRepo;
    private $userDetailRepo;

    public function __construct(
        UserRepository $userRepo,
        RoleRepository $roleRepo,
        BiodataRepository $biodataRepo,
        UserdetailRepository $userDetailRepo
    ) {
        $this->userRepo = $userRepo;
        $this->roleRepo = $roleRepo;
        $this->biodataRepo = $biodataRepo;
        $this->userDetailRepo = $userDetailRepo;
    }

    public function login_reviewer($nip)
    {
        $user = $this->userRepo->find(null, $nip, null);

        $ada_data = ModelHasRoles::where([
            ['model_id', '=', $user->id]
        ])->count();

        if ($ada_data == 0)
        {
            $data_role['role_id'] = '2619bc99-0027-4997-9510-d4736bd26862';
            $data_role['model_type'] = 'App\Models\User';
            $data_role['model_id'] = $user->id;

            ModelHasRoles::create($data_role);
        }


        if ($user) {
            return 'sudah ada';
        } else {
            return $this->getAddReviewer($nip);
        }
    }

    private function getAddReviewer($nip)
    {
        $id = (string) Str::uuid();
        $data = collect([
            (object) [
                'jenis' => 'P',
                'userid' => $nip
            ]
        ]);
        $biodata = $this->biodataRepo->biodata($data->toArray());
        $user = $this->userRepo->storeSso($id, $biodata);
        $roles = $this->roleRepo->roles('reviewer');
        $this->userDetailRepo->storeSso($user->id, $biodata);
        $this->roleRepo->store($user, $roles);

        return 'sukses';
    }
}
